* PROGRAM NAME: BUILD_SS_FORMAT_CMS.SAS;

LIBNAME FORM "&FORMDIR";

DATA _NULL_;
  CALL SYMPUT('NUM',TRIM(LEFT(PUT(NUMOBS,4.))));
  STOP;
  SET FORM.PARTDSENIORSAVINGSMODEL NOBS=NUMOBS;
  STOP;
RUN;

%MACRO SSFMT;
  %IF &NUM > 0 %THEN %DO;
    DATA FMT FMTLAST;
      SET FORM.PARTDSENIORSAVINGSMODEL END=LAST;
      LENGTH START $19 LABEL $1 FMTNAME $8 HLO $1;
      LENGTH SEGMENT_ID_N 3;
      SEGMENT_ID_N = INPUT(SEGMENT_ID,3.);
      START=CONTRACT_ID || PLAN_ID || PUT(SEGMENT_ID_N,Z3.) || RXCUI;  
      LABEL=COHORT;
      FMTNAME='$SSFMT';
      HLO=' ';
      OUTPUT FMT;
      IF LAST THEN DO;
        OUTPUT FMTLAST;
        START='OTHER';
        LABEL=' ';
        HLO='O';
        OUTPUT FMT;
        OUTPUT FMTLAST;
      END;
      KEEP START LABEL FMTNAME HLO;
    RUN;
  %END;
  %ELSE %DO;
    DATA FMT FMTLAST;
      FMTNAME='$SSFMT';
      START='OTHER';
      LABEL=' ';
      HLO='O';
      OUTPUT FMT;
      OUTPUT FMTLAST;
      KEEP START LABEL FMTNAME HLO;
    RUN;
  %END;
%MEND;

%SSFMT;

PROC SORT DATA=FMT NODUPKEY;
  BY START;
RUN;

PROC FORMAT CNTLIN=FMT LIBRARY=LIBRARY;
RUN;